import {Injectable} from '@angular/core';
import {DayPilot} from 'daypilot-pro-angular';
import {HttpClient} from '@angular/common/http';
import {Observable} from 'rxjs';

@Injectable()
export class DataService {

  resources: any[] = [...Array(100).keys()].map(makeResource);

  events: any[] = [...Array(100).keys()].map(id => makeEvent(id));


  constructor(private http: HttpClient) {
  }

  getEvents(from: DayPilot.Date, to: DayPilot.Date): Observable<any[]> {

    // simulating an HTTP request
    return new Observable(observer => {
      setTimeout(() => {
        observer.next(this.events);
      }, 200);
    });

    // return this.http.get("/api/events?from=" + from.toString() + "&to=" + to.toString());
  }

  getResources(): Observable<any[]> {

    // simulating an HTTP request
    return new Observable(observer => {
      setTimeout(() => {
        observer.next(this.resources);
      }, 200);
    });

    // return this.http.get("/api/resources");
  }

}

function makeResource(id: number): any {
  return {
    name: `Resource ${id}`,
    id: `${id}`
  };
}

function makeEvent(id: number): any {
  return {
    id: `${id}`,
    resource: `${id}`,
    start: '2020-02-07',
    end: '2020-02-10',
    text: `Event ${id}`,
  };
}